package com.jkcredit.invoice.service.nocar.impl;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.jkcredit.invoice.mapper.customer.CustomerCarRecMapper;
import com.jkcredit.invoice.mapper.waybill.NoCarWaybillMapper;
import com.jkcredit.invoice.model.entity.customer.CustomerCarRec;
import com.jkcredit.invoice.model.entity.waybill.NoCarWayBill;
import com.jkcredit.invoice.service.lowerService.NoCarService;
import com.jkcredit.invoice.service.nocar.NoCarBillWayService;
import com.jkcredit.invoice.util.RespR;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

import java.util.ArrayList;
import java.util.List;
@Service
public class NoCarBillWayServiceImpl extends ServiceImpl<NoCarWaybillMapper,NoCarWayBill> implements NoCarBillWayService{
    @Autowired
    NoCarWaybillMapper noCarWaybillMapper;

    @Autowired
    CustomerCarRecMapper customerCarRecMapper;

    @Autowired
    NoCarService noCarService;
    @Override
    public IPage<List<NoCarWayBill>> findByPageAndWayBill(Page page, NoCarWayBill noCarWayBill) {
        return noCarWaybillMapper.selectAllByPage(page,noCarWayBill);
    }

    @Override
    public IPage<List<NoCarWayBill>> findByPageAndWayBillException(Page page, NoCarWayBill noCarWayBill) {
        return noCarWaybillMapper.selectAllByPageException(page,noCarWayBill);
    }

    @Override
    public RespR batchBillWayStart(List<NoCarWayBill> noCarWayBills) {
        StringBuffer stringBuffer = new StringBuffer();
        noCarWayBills.parallelStream().forEach(noCarWayBill -> {
            //1.查询是否有车辆备案
            CustomerCarRec customerCarRec = customerCarRecMapper.selectByCarNum(noCarWayBill.getPlateColor());

            //2.无车车辆备案时进行车辆备案
            if(customerCarRec== null || customerCarRec.getRecStatus()!=1){
                List<CustomerCarRec> customerCarRecs = new ArrayList<>();
                customerCarRecs.add(customerCarRec);
                RespR respR = noCarService.customerCarRec(customerCarRecs);
                if(respR.getCode() ==1){
                    return;
                }else{
                    stringBuffer.append("#").append(noCarWayBill.getBillNum()).append(":").append(respR.getMsg()).append("#");
                }
            }

            //3.进行上传
            RespR respR = noCarService.noCarHisWaybillStart(noCarWayBill);
            if (respR.getCode() == 1){
                stringBuffer.append("#").append(noCarWayBill.getBillNum()).append(":").append(respR.getMsg()).append("#");
            }
        });
        if(StringUtils.isEmpty(stringBuffer.toString())){
            return new RespR(false,stringBuffer.toString());
        }
        return new RespR(Boolean.TRUE);
    }

}
